package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.util.ByteSequence;
import java.io.IOException;
import java.io.DataOutputStream;

public class SIPUSH extends Instruction implements ConstantPushInstruction
{
    private short b;
    
    SIPUSH() {
    }
    
    public SIPUSH(short b) {
        super((short)17, (short)3);
        this.b = b;
    }
    
    @Override
    public void dump(DataOutputStream out) throws IOException {
        super.dump(out);
        out.writeShort((int)this.b);
    }
    
    @Override
    public String toString(boolean verbose) {
        return super.toString(verbose) + " " + (int)this.b;
    }
    
    @Override
    protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException {
        super.setLength(3);
        this.b = bytes.readShort();
    }
    
    @Override
    public Number getValue() {
        return Integer.valueOf((int)this.b);
    }
    
    @Override
    public Type getType(ConstantPoolGen cp) {
        return Type.SHORT;
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitPushInstruction(this);
        v.visitStackProducer(this);
        v.visitTypedInstruction(this);
        v.visitConstantPushInstruction(this);
        v.visitSIPUSH(this);
    }
}
